import { ElementType, useState } from "react";

export const WithHocToggle = (Component: ElementType) => {
  return function WithHocToggleComponent({ ...props }: {
    [key: string]: any;
  }) {
    const [toggle, setToggle] = useState<boolean>(false);

    return (
      <Component
        toggle={(
          trueClass: string = 'show',
          falseClass: string = '',
          extraCondition: any = null
        ) => (extraCondition) || toggle ? trueClass : falseClass}
        setToggle={() => setToggle(!toggle)}
        {...props}
      />
    );
  };
};

export type ToggleType = (
  trueClass?: string,
  falseClass?: string,
  extraCondition?: any
) => string;

export type SetToggleType = () => void;
